
include Custom Open File Dialog.inc

.code

start:
    invoke	GetModuleHandle,NULL
    mov	    hInst,  eax
    invoke  GetProcessHeap
    mov     hMainHeap, eax
    
    invoke	InitCommonControls
    invoke	DialogBoxParam,hInst,IDD_MAIN,NULL,addr MainDlg,NULL
    invoke	ExitProcess,0

MainDlg	proc	hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    
    mov	eax,uMsg
    .if	eax==WM_INITDIALOG		
        invoke  GetDlgItem, hWin, IDC_IMG_LRG
        mov     hImg32, eax
                
        invoke  GetDlgItem, hWin, IDC_IMG_SM
        mov     hImg16, eax
        
    .elseif	eax==WM_COMMAND
        mov edx,wParam
        movzx eax,dx
        shr edx,16
        .if edx==BN_CLICKED
            .if eax==IDC_OK
                invoke  RtlZeroMemory, addr ofn, sizeof ofn
                mov     ofn.lStructSize, sizeof OPENFILENAME
                push    hWin
                pop     ofn.hwndOwner
                push    hInst
                pop     ofn.hInstance
                mov     ofn.lpstrFilter, offset DlgFilter
                mov     ofn.lpstrTitle, offset DlgTitle
                mov     ofn.Flags, OFN_EXPLORER or OFN_ENABLETEMPLATE \
                          or OFN_ENABLEHOOK or OFN_HIDEREADONLY 
                mov     ofn.lpfnHook, offset DlgHook
                mov     ofn.lpTemplateName, IDD_DLG		                
                invoke  GetOpenFileName, addr ofn

            .elseif eax==IDC_CANCEL
                invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL
            .endif
        .endif
        
    .elseif	eax==WM_CLOSE
        invoke  SendMessage, hImg32, STM_GETICON, 0, 0
        invoke  DestroyIcon, eax
        
        invoke  SendMessage, hImg16, STM_GETICON, 0, 0
        invoke  DestroyIcon, eax
        
        invoke	EndDialog,hWin,0
    .else
        mov	eax,FALSE
        ret
    .endif
    mov	eax,TRUE
    ret
MainDlg endp

DlgHook proc uses esi edi ebx hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov		eax,uMsg
    .if eax==WM_INITDIALOG
        ; Image list for browse for icons dialog
        invoke  ImageList_Create, 32, 32, ILC_MASK or ILC_COLORDDB, 2, 500
        mov     himlDlg, eax

        ; Get handle to open file dialog
        invoke  GetParent, hWin
        mov     ebx, eax
        mov     hParent, eax
        
        ; I don't want these 3 controls, so hide em
        ; Hide file name static control
        invoke  SendMessage, eax, CDM_HIDECONTROL, stc3, 0
        ; Hide file name edit control
        invoke  SendMessage, ebx, CDM_HIDECONTROL, edt1, 0
        ; Hide ok button
        invoke  SendMessage, ebx, CDM_HIDECONTROL, IDOK, 0
        
        ; Now move the next 3 controls up
        ; Adjust file type static top
        invoke  memfill, offset tTR, sizeof RECT, NULL
        invoke  memfill, offset wLp, sizeof POINT, NULL
        
        invoke  GetDlgItem, ebx, stc2
        mov     edi, eax
        
        invoke  GetWindowRect, edi, offset tTR
        invoke  ScreenToClient, ebx, offset wLp
        mov     eax, wLp.x
        add     eax, tTR.left
        mov     esi, wLp.y
        add     esi, tTR.top
        sub     esi, 30
        invoke  SetWindowPos, edi, 0, eax, esi, 0, 0, SWP_NOSIZE

        ; Adjust file type combo top
        invoke  GetDlgItem, ebx, cmb1
        mov     edi, eax
        
        invoke  GetWindowRect, edi, offset tTR
        mov     eax, wLp.x
        add     eax, tTR.left
        sub     esi, 4
        invoke  SetWindowPos, edi, 0, eax, esi, 0, 0, SWP_NOSIZE
        
        ; Adjust cancel button top
        invoke  GetDlgItem, ebx, IDCANCEL
        mov     edi, eax
        
        invoke  GetWindowRect, edi, offset tTR
        mov     eax, wLp.x
        add     eax, tTR.left
        sub     esi, 4
        invoke  SetWindowPos, edi, 0, eax, esi, 0, 0, SWP_NOSIZE
        
        ; Get handle to our listview
        invoke  GetDlgItem, hWin, IDC_LSV1
        mov     hLVDlg, eax
        
        ; Set image list to listview
        invoke  SendMessage, eax, LVM_SETIMAGELIST, LVSIL_NORMAL, himlDlg
  
        push    hWin
        pop     hMainDlg
        
    .elseif eax==WM_COMMAND
        mov		edx,wParam
        movzx	eax,dx
        shr		edx,16
        .if edx==BN_CLICKED
            .if eax==IDOK

            .elseif eax==IDCANCEL
                invoke  SendMessage, hWin, WM_CLOSE, NULL, NULL
            .endif
        .endif
        
    .elseif eax == WM_NOTIFY
        .if wParam == IDC_LSV1
            mov     eax, lParam
            .if dword ptr(NMHDR ptr [eax]).code == LVN_ITEMCHANGING
                .if dword ptr(NMLISTVIEW ptr [eax]).uNewState == LVIS_FOCUSED or LVIS_SELECTED
                    invoke  ImageList_GetIcon, himlDlg, dword ptr(NMLISTVIEW ptr [eax]).iItem, ILD_TRANSPARENT
                    push    eax
                    invoke  SendMessage, hImg32, STM_SETICON, eax, 0
                    invoke  DestroyIcon, eax
                    pop     eax
                    
                    invoke  CopyImage, eax, IMAGE_ICON, 16, 16, LR_COPYFROMRESOURCE
                    invoke  SendMessage, hImg16, STM_SETICON, eax, 0
                    invoke  DestroyIcon, eax
                    
                    invoke  PostMessage, hParent, WM_CLOSE, 0, 0
                    ret
                .else
                    jmp     PassThrough
                .endif
            .else
                jmp     PassThrough
            .endif
            
        .else
            mov     eax, lParam
            .if dword ptr(NMHDR ptr [eax]).code == CDN_SELCHANGE
                ; Get path of selected file
                mov     byte ptr [DlgFilePath], 0
                invoke  memfill, offset DlgFilePath, MAX_PATH + 1, NULL
                invoke  SendMessage, hParent, CDM_GETFILEPATH, MAX_PATH + 1, offset DlgFilePath
                invoke  PathFindExtension, offset DlgFilePath
                invoke  Cmpi, eax, offset szExtIco
                test    eax, eax
                jz      @F
                call    ShowIcons
                @@:
                jmp     PassThrough
                
            .elseif dword ptr(NMHDR ptr [eax]).code == CDN_FILEOK
                invoke  PathFindExtension, offset DlgFilePath
                invoke  Cmpi, eax, offset szExtIco
                .if eax == 0
                    ; Icon was selected, show 32 and 16 sizes
                    invoke  LoadImage, NULL, offset DlgFilePath, IMAGE_ICON, 32, 32, LR_LOADFROMFILE
                    push    eax
                    invoke  SendMessage, hImg32, STM_SETICON, eax, 0
                    invoke  DestroyIcon, eax
                    pop     eax
                    
                    invoke  CopyImage, eax, IMAGE_ICON, 16, 16, LR_COPYFROMRESOURCE
                    invoke  SendMessage, hImg16, STM_SETICON, eax, 0
                    invoke  DestroyIcon, eax
                    ; close the dialog
                    invoke  SetWindowLong, hWin, DWL_MSGRESULT, FALSE
                .else
                    ; not an ico file, leave dialog open
                    invoke  SetWindowLong, hWin, DWL_MSGRESULT, TRUE
                .endif
                
            .else
                jmp     PassThrough    
            .endif
        .endif
    .elseif eax==WM_CLOSE
        invoke  ImageList_Destroy, himlDlg
        invoke  DestroyWindow, hWin
    .else
        PassThrough:
            mov		eax, FALSE
            ret
    .endif
    
    mov		eax, TRUE
    ret

DlgHook endp

ShowIcons proc
LOCAL   hLib:DWORD
    ; Clear imagelist
    invoke  ImageList_Remove, himlDlg, -1

    ; Clear listview
    invoke  SendMessage, hLVDlg, LVM_DELETEALLITEMS, 0, 0
    
    ; is the path a directory?  If yes, leave
    invoke  PathIsDirectory, offset DlgFilePath
    test    eax, eax
    jnz     Done
    
    ; Get icon count
    invoke  ExtractIcon, hInst, offset DlgFilePath, -1
    test    eax, eax
    jnz      @F
    invoke  SetDlgItemInt, hMainDlg, 2002, eax, FALSE
    jmp     Done
    
    @@:
    invoke  SetDlgItemInt, hMainDlg, 2002, eax, FALSE
    ; We have icons! load the file
    invoke  LoadLibraryEx, offset DlgFilePath, 0, LOAD_LIBRARY_AS_DATAFILE
    test    eax, eax
    jz      Done
    mov     hLib, eax
    
    ; Now get all the icon names
    invoke  EnumResourceNames, eax, RT_GROUP_ICON, offset EnumResNamesProc, 0
    invoke  FreeLibrary, hLib
   
   Done:
   ret
ShowIcons endp

IS_INTRESOURCE proc IcoID:DWORD   
   mov   eax, IcoID
   shr   eax, 16
   ret
IS_INTRESOURCE endp


EnumResNamesProc proc uses esi hModule:DWORD,lpszType:DWORD, lpszName:DWORD, lParam:DWORD
LOCAL   IconTemp:DWORD
LOCAL   LVParam:DWORD
    invoke  LoadImage, hModule, lpszName, IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR
    mov     IconTemp, eax
    invoke  ImageList_ReplaceIcon, himlDlg, -1, IconTemp
    invoke  DestroyIcon, IconTemp
    invoke  ImageList_GetImageCount, himlDlg
    sub     eax, 1
   
    mov     lvi.imask, LVIF_IMAGE or LVIF_TEXT
    mov     lvi.iItem, eax
    mov     lvi.iSubItem, 0
    mov     lvi.iImage, eax
   
    invoke  HeapAlloc, hMainHeap, HEAP_ZERO_MEMORY, 50
    mov     LVParam, eax
    
    invoke  memfill, LVParam, 50, 0
    invoke  IS_INTRESOURCE, lpszName
    test    eax, eax
    jz      @F
    
    invoke  StrLen, lpszName
    invoke  MemCopy, lpszName, LVParam, eax
    jmp     Continue
    
    @@:
    invoke  dwtoa, lpszName, LVParam
   
    Continue:
        mov     eax, LVParam
        mov     lvi.pszText, eax

        invoke  SendMessage, hLVDlg, LVM_INSERTITEM, 0, addr lvi
        
        invoke  HeapFree, hMainHeap, 0, LVParam

        mov     eax, TRUE
        ret
EnumResNamesProc endp
end start
